package com.chinacreator.kafka;

import javax.sql.DataSource;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.scheduling.annotation.EnableScheduling;

@SpringBootApplication
@EnableScheduling
@EnableCaching
@MapperScan({"com.chinacreator.kafka.mapper"})
public class Application implements CommandLineRunner{

	public static void main(String[] args) {
		//SpringApplication.run(Application.class, args);
		//不以web应用启动
		new SpringApplicationBuilder().sources(Application.class).web(false).run(args);
        System.out.println("/*************************测试fastjson升级是否成功开始*************************/");
        System.out.println("输出下面内容代表成功： ");
        System.out.println("com.alibaba.fastjson.JSONException: safeMode not support autoType : java.net.InetSocketAddress");
        try {
            String jsonStr = "{\"x\":{\"@type\":\"java.net.InetSocketAddress\"{\"address\":,\"val\":\"x.threatbook.com\"}}}";
            Object json1 = com.alibaba.fastjson.JSONObject.parse(jsonStr);
            System.out.println("测试输出内容=>"+json1);
        } catch (Exception e) {
            //e.printStackTrace();
            System.out.println("输出信息=》"+e.getMessage());
        }
        System.out.println("/**************************测试fastjson升级是否成功结束************************/");
	}
	
	@Autowired
    DataSource dataSource;

    @Override
    public void run(String... args) throws Exception {
     System.out.println(dataSource.getClass()+" = " + dataSource);
    }
}
