package com.chinacreator.kafka.handle;

import java.util.HashMap;

import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.springframework.stereotype.Component;

import com.chinacreator.kafka.consumer.KafkaConsumerComm;
import com.chinacreator.kafka.util.ThreadLimitUtil;

@Component
public abstract class KakfaBaseHandle {
	public KafkaConsumer<String, String> getConsumer() {
		return consumer;
	}

	public void setConsumer(KafkaConsumer<String, String> consumer) {
		this.consumer = consumer;
	}

	public String getTopic() {
		return topic;
	}

	public void setTopic(String topic) {
		this.topic = topic;
	}

	public String getGroupid() {
		return groupid;
	}

	public void setGroupid(String groupid) {
		this.groupid = groupid;
	}

	public String getThreadkey() {
		return threadkey;
	}

	public void setThreadkey(String threadkey) {
		this.threadkey = threadkey;
	}

	private KafkaConsumer<String, String> consumer = null;
	private String topic = ""; //conf.get("TOPIC").toString();
	private String groupid = ""; //conf.get("GROUPID").toString();
	private String threadkey = ""; //topic+"##"+groupid;
	
	public KafkaConsumer<String, String> init(HashMap conf){
		topic = conf.get("TOPIC").toString();
		groupid = conf.get("GROUPID").toString();
		//threadkey = topic+"##"+groupid;
		threadkey = conf.get("THREADKEY").toString();
		if(consumer == null){
			String bookerServer = conf.get("BOOKERSERVER").toString(); //服务器地址
			String username = conf.get("USERNAME").toString(); //登录用户名
			String password = conf.get("PASSWORD").toString(); //登录用户
			String authFilePath = conf.get("AUTHFILEPATH")+""; //权限验证文件路径，已不使用此属性
			String records = conf.get("RECORDS").toString(); //每次取数据条数
			ThreadLimitUtil.setRecordsMax(threadkey, records); //设置当前topic最大取数据条数
			consumer = new KafkaConsumerComm().getConsumber(bookerServer,groupid,username,password,authFilePath,records, topic);	
		}
		return consumer;
	}
	
	public abstract void doHandle(HashMap conf);
}
