package com.chinacreator.kafka.handle.impl;

import java.util.HashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import org.apache.kafka.clients.consumer.KafkaConsumer;
import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.chinacreator.kafka.consumer.KafkaConsumerComm;
import com.chinacreator.kafka.handle.KakfaBaseHandle;
import com.chinacreator.kafka.mapper.SourceDataRecDao;
import com.chinacreator.kafka.thread.NoticeGprsstopThread;
import com.chinacreator.kafka.util.ThreadLimitUtil;

/**
 * NoticeGprsstop处理类
 * @author xu.zhou
 * @date 20201203
 */
@Component("NoticeGprsstopHandle")
public class NoticeGprsstopHandle extends KakfaBaseHandle{
	
	private static Logger log = Logger.getLogger(NewProdInfoHandle.class);
	
	@Autowired
	SourceDataRecDao sourceDataRecDao;

	public void doHandle(HashMap conf) {
		/***
		String topic = conf.get("TOPIC").toString();
		String groupid = conf.get("GROUPID").toString();
		String threadkey = topic+"##"+groupid
		***/
		boolean hasCancel = false;
		try {
			//第一个组ID： Online-group-01
			/***
			String bookerServer = conf.get("BOOKERSERVER").toString(); //服务器地址
			String username = conf.get("USERNAME").toString(); //登录用户名
			String password = conf.get("PASSWORD").toString(); //登录用户
			String authFilePath = conf.get("AUTHFILEPATH").toString(); //权限验证文件路径
			String records = conf.get("RECORDS").toString(); //每次取数据条数
			KafkaConsumer<String, String> consumer = new KafkaConsumerComm().getConsumber(bookerServer,groupid,username,password,authFilePath,records);
			***/
			KafkaConsumer<String, String> consumer = super.init(conf);
			ExecutorService executor = Executors.newFixedThreadPool(3);
			executor.submit(new NoticeGprsstopThread(conf, consumer, sourceDataRecDao));
			log.info("Threadkey=>"+super.getThreadkey()+"客户端初始化完成");
		} catch (Exception e) {
			e.printStackTrace();
			hasCancel = true;
			log.error(super.getThreadkey()+":实例消费线程出现异常，"+e.getMessage(),e);
		} finally{
			if(hasCancel){
				ThreadLimitUtil.removeKey(super.getThreadkey());
			}
		}	
	}
}
