package com.chinacreator.kafka.job;

import java.util.Date;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import ch.qos.logback.classic.Logger;

import com.chinacreator.kafka.quartz.QuartzService;
import com.chinacreator.kafka.service.KafkaDataService;
import com.chinacreator.kafka.service.KuaishouService;
import com.chinacreator.kafka.util.SpringContextUtils;
import com.chinacreator.kafka.service.DouyinService;
import com.chinacreator.kafka.service.ChengkaService;
import com.chinacreator.kafka.service.ChengkaFlowService;

@Component
public class KafkaOrderJob {
	
	/**
	 * 消费KAFKA数据
	 * @throws Exception
	 */
	//@Scheduled(fixedDelay = 60000)
	@Scheduled(fixedDelayString = "${config.kafka.fixedDelay}") 
	public void getKafkaData() throws Exception{
		System.out.println("KAFKA消费数据>>>>>>>>"+new Date());		
		KafkaDataService service = (KafkaDataService) SpringContextUtils.getBean(KafkaDataService.class);
		service.process();
	}
	
	/**
	 * 快手数据处理
	 * @throws Exception
	 */
	/***
	@Scheduled(fixedDelay = 10000)
	public void procByKuaishou() throws Exception{
		System.out.println("快手>>>>>>>>"+new Date());		
		KuaishouService service = (KuaishouService) SpringContextUtils.getBean(KuaishouService.class);
		service.process();
	}
	**/

	/**
	 * 抖音数据处理
	 * @throws Exception
	 */
	//@Scheduled(fixedDelay = 2000)
	/***
	@Scheduled(fixedDelayString = "${config.douyin.fixedDelay}")
	public void DouyinService() throws Exception{
		System.out.println("抖音>>>>>>>>"+new Date());		
		DouyinService service = (DouyinService) SpringContextUtils.getBean(DouyinService.class);
		service.process();
	}
	****/
		
	@Scheduled(fixedDelayString = "${config.jobTask.fixedDelay}")  
	public void jobTask(){
		try {
			System.out.println("数据处理定时任务刷新>>>>>>>>"+new Date());
			QuartzService service = (QuartzService) SpringContextUtils.getBean(QuartzService.class);
			service.process();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
