package com.chinacreator.kafka.mapper;

import java.util.HashMap;
import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.springframework.cache.annotation.CacheConfig;
import org.springframework.cache.annotation.Cacheable;

import com.chinacreator.kafka.bean.KafkaBean;
import com.chinacreator.kafka.bean.OrderInfo;
import com.chinacreator.kafka.bean.ProvinceBean;
import com.chinacreator.kafka.bean.TbKafkaJobConf;
import com.chinacreator.kafka.sync.bean.BoYuanLogBean;

/**
 * 活动数据处理dao
 * @author xu.zhou
 * @date 20220216
 */
public interface ActivityHandleDao {
	
	/**
	 * 查询活动配置信息
	 * @return
	 */
	List<HashMap> qryAcproductConf(@Param("activitycode")String activitycode);

	/**
	 * 添加虎年开门红活动数据
	 * @param params
	 * @return
	 */
	int addActiveDataByTiger(HashMap<String, String> params);
		
	/**
	 * 获取ID
	 * @return
	 */
	String getNo();

	/**
	 * 获取orderchannel2 根据订购关系表id
	 * @return
	 */
	HashMap getOrderData(@Param("relid")String relid);

	/**
	 * 添加【促回流】活动数据
	 * @param params
	 * @return
	 */
	int addActiveDataByReFlow(HashMap<String, String> params);

	/**
	 * 添加【517电信券码】活动数据
	 * @param params
	 * @return
	 */
	int addActiveDataTelecom(HashMap<String, String> params);

    /**
     * 查找【517电信券码】活动数据
     * @param params
     * @return
     */
    HashMap queryActiveDataTelecom(HashMap<String, String> params);

    /**
     * 更新【517电信券码】活动数据
     * @param params
     * @return
     */
    int updateActiveDataTelecom(HashMap<String, String> params);


	/**
	 * 添加【千人千面券码】活动数据
	 * @param params
	 */
	void addActiveDataByCancel(HashMap<String, String> params);

	/**
	 * 查最近的劵码领取记录
	 * @param params
	 * @return
	 */
	HashMap<String, Object> qryActiveDataByCancel(HashMap<String, String> params);

	void updateActiveDataCancel(HashMap<String, Object> map);


	/**
	 * 优酷订购用户送定向流量活动
	 * @param params
	 * @return
	 */
	int addActiveDataByYoutu(HashMap<String, String> params);

}
