package com.chinacreator.kafka.mapper;

import com.chinacreator.kafka.bean.*;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * @Author shuiying.ou
 * @Date 2022-03-21 17:48
 * @DESCRIPTION 回流数据处理
 */
public interface ActivityReflowDao {

    // 获取需要处理的原始数据
    List<CheckData> selectData();

    // 修改原始数据的状态
    void updateData(@Param("resultcode") String resultcode, @Param("resultinfo") String resultinfo, @Param("sequenceId") String sequenceId);

    // 根据产品id查spid
    List<SpInfo> selectSpInfo(String productId);

    // 查询近五分钟的订购日志
    List<OrderLog> selectOrderLog(@Param("userid") String serviceId, @Param("spid") String spid);

    // 推送短信记录入库
    void insertReflowBean(ReflowBean reflowBean);

    // 查询对应的短信内容
    String findSmstxt(String spid);

    // 查询是否有推送记录
    ReflowBean qrySmsRec(@Param("spid") String spid, @Param("userid") String serviceId);

    // 更新短信结果内容
    void updSmsRec(@Param("id") String id, @Param("resultcode") String resultcode, @Param("resultinfo") String resultinfo);


    //获取订购关系
    OrderInfo findByUserAndSpid(@Param("userid") String userid, @Param("spid") String spid);

    // 查询券码记录
    int selectCouponLog(@Param("userid") String serviceId, @Param("spid") String spid,@Param("activitycode")String activitycode );

    // 查询退订用户的信息
    OrderInfo findOrderInfo(@Param("userid") String serviceId, @Param("spid") String spid);

    // 查询合约时间
    Integer getMonth(String spid);

    Date selectEndTime(String spid);

    //查看是否有推送记录（历史）
    // 查询是否有推送记录
    int qrySmsRecHis(@Param("spid") String spid, @Param("userid") String serviceId,@Param("activitycode")String activitycode);

    // 查询是否有推送记录（挽回短信）
    int qrySmsRecHisWH(@Param("spid") String spid, @Param("userid") String serviceId,@Param("activitycode")String activitycode);

    // 记录闪信
    void insertFlashBean(ReflowBean bean);

    // 更新闪信结果内容
    void updateSendFlashLog(@Param("id") String id, @Param("resultcode") String resultcode, @Param("resultinfo") String resultinfo);

    // 查询10s之前发送过回流短信的数据
    List<ReflowBean> findSms();

    List<SpInfo> selectSpNameBySpid(String spid);

    void updSms(@Param("id") String id, @Param("status") String status);

    Integer selectTotalData();

    HashMap<String, Object> getNumber(String threeReflowBack);

    List<ReflowBean> selectThreeReflowData(int number);

    List<ReflowBean> selectOtherData();

    void updateBackData(@Param("backcode") String backcode, @Param("id") String id);

    List<OrderInfo> findOrderRel(@Param("userid") String userid, @Param("spid") String spid);

    String getEcredit(String getEcredit);

    String getPwd(String channel);

    void updateNumber(Integer remark2);

    AcproductConfigBean selectAcproduct(String spid);

    SpInfo getDirectype(String spid);

    void insertBackBean(ReflowBean bean);

    void updBackSms(ReflowBean reflowBean);

    ReflowBean getSmsContent(String id);

    String getSMSDetails(String threeReflowBackSMS);

    List<String> findAsynch(@Param("userid") String serviceId, @Param("spid") String spid);

    ReflowBean qrySmsBack(@Param("spid") String spid, @Param("userid") String userid);


    List<ReflowBean> qryThreeReflowData();

    void updateThreeReflowData(@Param("resultcode") String resultcode, @Param("resultinfo") String resultinfo, @Param("id") String id);


    ReflowBean selectSendLog(@Param("userid") String userid, @Param("spid") String spid, @Param("activitycode") String activitycode);

    void insertInvokeLog(ReflowInvokeLog reflowInvokeLog);

    SpInfo qrySpInfo(@Param("spid") String spid, @Param("activitycode") String activitycode);


}
