package com.chinacreator.kafka.mapper;

import java.util.HashMap;
import java.util.List;

import org.apache.ibatis.annotations.Param;

/**
 * 前向产品到期自动退订
 * @author xu.zhou
 * @date 20220722
 */
public interface PrevAutoCancelDao {
	
	/**
	 * 根据订购关系表ID获取数据
	 * @param relid
	 * @return
	 */
	HashMap qryRecByRelid(@Param("relid")String relid);
	
	/**
	 * 添加订购数据到TD_PREV_AUTOCANCEL_REC表
	 * @param recmap
	 * @return
	 */
	int addRecOrder(HashMap params);
	
	/**
	 * 添加退订数据到TD_PREV_AUTOCANCEL_REC表
	 * @param recmap
	 * @return
	 */
	int addRecCancel(HashMap params);
	
	/**
	 * 添加到执行日志表，一条执行数据只允许添加一条数据，防止同一数据重复成功执行，造成rec表的数据信息紊乱
	 * @param params
	 * @return
	 */
	int addRecLog(HashMap params);
	
	/**
	 * 更新执行日志表的结果信息
	 * @param params
	 * @return
	 */
	int updRecLog(HashMap params);
	
	/**
	 * 订购更新
	 * @param recmap
	 * @return
	 */
	int updRecOrder(HashMap params);
	
	/**
	 * 退订更新
	 * @param recmap
	 * @return
	 */
	int updRecCancel(HashMap params);
	
	/**
	 * 更新执行自动退订状态
	 * @param params
	 * @return
	 */
	int updExecAutocancel(HashMap params);
		
	/**
	 * 获取要处理的数据
	 * @return
	 */
	List<HashMap> qryAutoCancelRec();
	
	/**
	 * 获取自动退订配置信息
	 * @param spid
	 * @return
	 */
	HashMap qryAutocancelConf(@Param("spid")String spid);
	
	/**
	 * 更新退订结果
	 * @param spid
	 * @param resultcode
	 * @param resultinfo
	 * @return
	 */
	int updCancelRes(@Param("spid")String spid, @Param("resultcode")String resultcode, @Param("spid")String resultinfo);
	
	/**
	 * 根据ID查询订购关系表获取数据
	 * @param relid
	 * @return
	 */
	HashMap qryRelById(@Param("relid")String relid);
	
	/**
	 * 添加待处理活动关系
	 * @param params
	 * @return
	 */
	int addBusshandleWait(HashMap params);
	
	/**
	 * 更新订购关系表为退订
	 * @param params
	 * @return
	 */
	int updRelCancel(HashMap params);
}
