package com.chinacreator.kafka.mapper;

import com.chinacreator.kafka.bean.SourceDataRecBean;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.cache.annotation.Cacheable;

import java.util.HashMap;
import java.util.List;

/**
 * 产品同步
 * @Author: xinlong.liu
 * @Date: 2022/3/30 13:47
 *
 */
public interface ProductSyncDao {

    //获取产品同步地址信息
    @Cacheable(value="invokeConf")
    List<HashMap<String, String>> getInvokeConfByChannel(@Param("channel")String channel);

    /**
     * 更新数据为同步中
     * @param id
     * @return
     */
    int updWaitSyncing(@Param("id")String id);

    /**
     * 根据id更新同步结果
     * @param id
     * @param resultcode
     * @param resultinfo
     * @return
     */
    void updProductWaitSync(@Param("id")String id, @Param("resultcode")String resultcode, @Param("resultinfo")String resultinfo);

    /**
     *
     *获取需要同步的数据
     * @param
     * @return
     *
     */
    List<HashMap<String ,String>> getProductWaitData();
}
