package com.chinacreator.kafka.mapper;

import java.util.HashMap;
import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.chinacreator.kafka.bean.ChengkaBean;
import com.chinacreator.kafka.bean.QueenCardBean;
import com.chinacreator.kafka.bean.SourceDataRecBean;

public interface SourceDataRecDao {
	
	/**
	 * 原始数据入库
	 * @param bean
	 * @return
	 */
	public int addCommomSrcData(SourceDataRecBean bean);
	
	/**
	 * 快手原始数据入库
	 * @param bean
	 * @return
	 */
	public int addKuaishouSrcData(SourceDataRecBean bean);
	
	/**
	 * 抖音原始数据入库
	 * @param bean
	 * @return
	 */
	public int addDouyinSrcData(SourceDataRecBean bean);
	
	
	/**
	 * 橙卡原始数据入库
	 * @param bean
	 * @return
	 */
	public int addChengkaSrcData(SourceDataRecBean bean);
	
	/**
	 * 橙卡原始数据入库
	 * @param bean
	 * @return
	 */
	public int addQueenCardSrcData(SourceDataRecBean bean);
	
	/**
	 * 添加橙卡数据
	 * @param bean
	 * @return
	 */
	public int addChengkaData(ChengkaBean bean);
	
	/**
	 * 获取抖音数据
	 * @param page 每次获取数据条数
	 * @return
	 */
	public List<SourceDataRecBean> getCommSrcData(@Param("page")int page);
	
	/**
	 * 获取抖音数据
	 * @param page 每次获取数据条数
	 * @return
	 */
	public List<SourceDataRecBean> getDouyinSrcData(@Param("page")int page);
	
	/**
	 * 获取抖音数据
	 * @param page 每次获取数据条数
	 * @return
	 */
	public List<SourceDataRecBean> getKuaishouSrcData(@Param("page")int page);
	
	/**
	 * 获取橙卡数据
	 * @param page 每次获取数据条数
	 * @return
	 */
	public List<SourceDataRecBean> getChengkaSrcData(@Param("page")int page);
	
	/**
	 * 获女王卡数据
	 * @param page 每次获取数据条数
	 * @return
	 */
	public List<SourceDataRecBean> getQueenCardSrcData(@Param("page")int page);
	
	/**
	 * 批量更新公共中间表为处理中
	 * @param beans
	 */
	public int updBatchCommSrcData(List<SourceDataRecBean> beans);
	
	/**
	 * 批量更新抖音中间表为处理中
	 * @param beans
	 */
	public int updBatchDouyinSrcData(List<SourceDataRecBean> beans);
	
	/**
	 * 批量更新快手中间表为处理中
	 * @param beans
	 */
	public int updBatchKuaishouSrcData(List<SourceDataRecBean> beans);
	
	
	/**
	 * 批量更新橙卡中间表为处理中
	 * @param beans
	 */
	public int updBatchChengkaSrcData(List<SourceDataRecBean> beans);
	
	/**
	 * 批量更新橙卡流量扣减数据
	 * @param beans
	 * @return
	 */
	public int updBatchChengkaFlowData(List<ChengkaBean> beans);
	
	/**
	 * 批量更新橙卡流量扣减数据
	 * @param beans
	 * @return
	 */
	public int updBatchQueenCardSrcData(List<SourceDataRecBean> beans);
	
	/**
	 * 执行更新动态SQL
	 * @param sql
	 * @return
	 */
	public int updSrcDataBySql(String sql);
	
	/**
	 * 获取要移除的数据
	 * @param sql
	 * @return
	 */
	public List<String> getMoveSrcDataBySql(String sql);
	
	/**
	 * 抖音数据添加到历史表
	 * @param ids
	 * @return
	 */
	public int moveBatchDouyinSrcData(List<String> ids);
	
	/**
	 * 删除抖音原数据
	 * @param ids
	 * @return
	 */
	public int delBatchDouyinSrcData(List<String> ids);
	
	/**
	 * 快手数据添加到历史表
	 * @param ids
	 * @return
	 */
	public int moveBatchKuaishouSrcData(List<String> ids);
	
	/**
	 * 删除快手原数据
	 * @param ids
	 * @return
	 */
	public int delBatchKuaishouSrcData(List<String> ids);
	
	/**
	 * 同步数据添加到历史表
	 * @param ids
	 * @return
	 */
	public int moveBatchSyncSrcData(List<String> ids);
	
	/**
	 * 删除同步原数据
	 * @param ids
	 * @return
	 */
	public int delBatchSyncSrcData(List<String> ids);
	
	/**
	 * 同步数据添加到历史表
	 * @param ids
	 * @return
	 */
	public int moveBatchRequestData(List<String> ids);
	
	/**
	 * 删除同步原数据
	 * @param ids
	 * @return
	 */
	public int delBatchRequestData(List<String> ids);
	
	/**
	 * 获取橙卡流量扣减数据
	 * @param page
	 * @return
	 */
	public List<ChengkaBean> getChengkaFlowData(@Param("page")int page);
		
	/**
	 * 更新女王卡的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @return
	 */
	public int updQueencardSrcDataRes(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id);
	
	/**
	 * 更新通用中间表的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @return
	 */
	public int updCommSrcDataRes(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id);
	
	/**
	 * 更新快手中间表的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @return
	 */
	public int updKuaishouSrcDataRes(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id);
	
	/**
	 * 更新抖音中间表的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @return
	 */
	public int updDouyinSrcDataRes(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id);
	
	/**
	 * 更新橙卡中间表的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @return
	 */
	public int updChengkaSrcDataRes(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id);
	
	/**
	 * 更新橙卡流量表的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @return
	 */
	public int updChengkaFlowDataRes(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id);
	
	/**
	 * 删除抖音原数据
	 * @param sql
	 * @return
	 */
	public int deldouyinSrcData(String sql);
	
	/**
	 * 根据ID删除抖音源数据
	 * @param id
	 * @return
	 */
	public int delDouyinSrcDataById(@Param("id")String id);
	
	/**
	 * 执行动态SQL
	 * @param sql
	 * @return
	 */
	public int execSql(String sql);
	
	/**
	 * 快手原始数据流量非百分之百消耗入库
	 * @param bean
	 * @return
	 */
	public int addKuaishouSrcDataTwo(SourceDataRecBean bean);
	
	/**
	 * 更新快手中间表的处理结果
	 * @param resultcode
	 * @param errorinfo
	 * @param id
	 * @param spid
	 * @param dealtime	 
	 * @return
	 */
	public int updKuaishouSrcDataResNew(@Param("resultcode")String resultcode, @Param("errorinfo")String errorinfo, @Param("id")String id, @Param("spid")String spid);
}
