package com.chinacreator.kafka.service;

import java.util.HashMap;
import java.util.List;
import org.jboss.logging.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.chinacreator.kafka.handle.KakfaBaseHandle;
import com.chinacreator.kafka.mapper.KafkaInfoDao;
import com.chinacreator.kafka.util.SpringContextUtils;
import com.chinacreator.kafka.util.ThreadLimitUtil;

@Service
public class KafkaDataService {
	
	private static Logger log = Logger.getLogger(KafkaDataService.class);
	
	@Autowired
	KafkaInfoDao kafkaInfoDao;
	
	public void process(){
		List<HashMap> dataList = kafkaInfoDao.getTopicConf();
		//DouYinHandle handle = (DouYinHandle)SpringContextUtils.getBean(DouYinHandle.class);
		//handle.doHandle();
		//KakfaBaseHandle abstractMqHandle = (KakfaBaseHandle) SpringContextUtils.getBean("DouYinHandle");
		//abstractMqHandle.doHandle();
		for(HashMap conf : dataList){
			String topic = "";
			String handle = "";
			String groupid = "";
			String clientflag = "";
			String threadkey = "";
			try {
				topic = conf.get("TOPIC").toString();
				handle = conf.get("HANDLE").toString();
				groupid = conf.get("GROUPID").toString();
				clientflag = conf.get("CLIENTFLAG") == null ? "1" : conf.get("CLIENTFLAG").toString();
				threadkey = topic+"##"+groupid+"##"+clientflag;
				conf.put("THREADKEY", threadkey);
				if(ThreadLimitUtil.getThread(threadkey) == 0){
					ThreadLimitUtil.setThread(threadkey);
					
					//Class handleClass = Class.forName(handle);
					//Object obj = handleClass.newInstance();
					//Runnable runnable = (Runnable)obj;
					//runnable.run();
					KakfaBaseHandle abstractMqHandle = (KakfaBaseHandle) SpringContextUtils.getBean(handle);
					abstractMqHandle.doHandle(conf);
				}else{
					KakfaBaseHandle abstractMqHandle = (KakfaBaseHandle) SpringContextUtils.getBean(handle);
					log.info("handle=>"+handle+", threadkey=>"+abstractMqHandle.getThreadkey()+", 线程数=>"+ThreadLimitUtil.getThread(threadkey));
				}
				//log.info(threadkey+" : "+ThreadLimitUtil.getThread(threadkey));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
}
