package com.chinacreator.test;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.transaction.PlatformTransactionManager;
import org.springframework.transaction.TransactionDefinition;
import org.springframework.transaction.TransactionStatus;

import com.alibaba.fastjson.JSON;
import com.chinacreator.kafka.Application;
import com.chinacreator.kafka.bean.BGbean;
import com.chinacreator.kafka.bean.DouyinBean;
import com.chinacreator.kafka.bean.KafkaBean;
import com.chinacreator.kafka.bean.KsSourceDataRecBean;
import com.chinacreator.kafka.bean.KuaishouBean;
import com.chinacreator.kafka.bean.OrderInfo;
import com.chinacreator.kafka.bean.SourceDataRecBean;
import com.chinacreator.kafka.mapper.ChannelSyncDao;
import com.chinacreator.kafka.mapper.KafkaInfoDao;
import com.chinacreator.kafka.mapper.SourceDataRecDao;
import com.chinacreator.kafka.util.JsonUtil;
import com.chinacreator.kafka.util.SpringContextUtils;

@RunWith(SpringRunner.class)
@SpringBootTest(classes = Application.class)
public class CommTest {

	@Autowired
	KafkaInfoDao kafkaInfo;
	@Autowired
	SourceDataRecDao sourceDataRecDao;
	@Autowired
	ChannelSyncDao channelSyncDao;
	
	@Test
	public void channelsyncTest(){
		List<HashMap> syncdata = channelSyncDao.getSyncBusi();
		System.out.println(syncdata);
	}
	
	@Test
	public void kuaishouTest(){
		KsSourceDataRecBean recBean = new KsSourceDataRecBean();;
		String percent = "";
		String serialNumber = "";
		List<String> percents = Arrays.asList("100","90","80");
		String dataJson = "{\"SERIAL_NUMBER\":\"18673197465\",\"ELEMENT_ID\":\"62995670\",\"REMAIN\":\"2999\",\"KAFKA_TYPE\":\"r\",\"DEAL_TIME\":\"20210310233300\",\"PERCENT\":\"70\",\"EPARCHY_CODE\":\"0531\",\"USER_ID\":\"1719082251262632\",\"ADD_PRODUCT_ID\":\"90761125\",\"USED_VALUE\":\"12.07\",\"PROVINCE_CODE\":\"17\"}";
		KuaishouBean bean = (KuaishouBean) JsonUtil.jsonToBean(dataJson, KuaishouBean.class);
		recBean.setSourcedata(dataJson);
		recBean.setResultcode("1");
		recBean.setResultinfo("待处理");
		recBean.setOldlogname("ksmsgb");
		if(percents.contains(bean.getPERCENT())){//流量消耗100%、90%、80%的才入库
			percent = bean.getPERCENT();
			serialNumber = bean.getSERIAL_NUMBER();
			recBean.setPercent(percent);
			recBean.setSerialNumber(serialNumber);
			//int rows = sourceDataRecDao.addKuaishouSrcData(recBean);
			//busilogger.info(topic+"执行数据入库已完成，影响行："+rows);
		}else{
			recBean.setResultcode("8001");
			recBean.setResultinfo("非指定流量消耗，不入库");
		}
		//System.out.println(JSON.toJSON(recBean));
		
		List<SourceDataRecBean> list = sourceDataRecDao.getKuaishouSrcData(50);
		//System.out.println(JSON.toJSON(list));
	}
	
	@Test
	public void kafkaInfotest() {

		Map<String,String> map = new HashMap<String, String>();
		map.put("userid", "18673197465");
		map.put("oldUserid", "1111111");
		map.put("type", "kfkchange");
		//System.out.println(kafkaInfo.qrySyncData(20));
		//OrderInfo info = new OrderInfo();
		//System.out.println(info.getOrderstatus());
		//String jsoninfo = "{\"id\":\"202012211143489938341\",\"cpid\":\"tencent\",\"spid\":\"79\",\"userid\":\"18697161902\",\"ordertime\":\"20201208234235\",\"effecttime\":\"20201221171509\",\"status\":0,\"orderchannel\":\"kafka\",\"ordertype\":0,\"orderstatus\":2,\"type\":0,\"isexperience\":0,\"showstatus\":\"\",\"canadd\":false,\"mutex\":\"\",\"paytype\":0,\"cachesucceed\":1,\"errorhandle\":0,\"batchid\":\"2020122117\"}";
		//info = (OrderInfo)JsonUtil.jsonToBean(jsoninfo, OrderInfo.class);
		/***
		String sql = "SELECT ID FROM (SELECT ID FROM NET3G.TD_KAFKA_SRCDATA_DOUYIN WHERE RESULTCODE = '0' AND INSERTTIME < SYSDATE -1/24) WHERE ROWNUM <= 1000";
		List<String> ids = sourceDataRecDao.getMoveSrcDataBySql(sql);
		System.out.println("==============="+ids);
		PlatformTransactionManager dataSourceTransactionManager = SpringContextUtils.getBean(PlatformTransactionManager.class);
		TransactionDefinition transactionDefinition = SpringContextUtils.getBean(TransactionDefinition.class);
		TransactionStatus transactionStatus = dataSourceTransactionManager.getTransaction(transactionDefinition);
		try {
			int rows = sourceDataRecDao.moveBatchDouyinSrcData(ids);
			System.out.println(rows);
			rows = sourceDataRecDao.delBatchDouyinSrcData(ids);
			dataSourceTransactionManager.commit(transactionStatus);//提交
		} catch (Exception e) {
			e.printStackTrace();
			dataSourceTransactionManager.rollback(transactionStatus);
		}
		****/
		
		/***
		List<HashMap> monitorList = kafkaInfo.getMonitorConf();
		String monisql = "";
		String id = "";
		int rows = 0;
		for(HashMap hm : monitorList){	
			if(hm.get("MONISQL") != null){
				monisql = hm.get("MONISQL").toString();
				id = hm.get("ID").toString();
				monisql = monisql.replace("#ID#", id);
				rows = kafkaInfo.updMonitorBySql(monisql);
				System.out.println(id+"，执行SQL影响行："+rows);
			}
		}
		****/
		//kafkaInfo.syncOrder(info);
		
		//System.out.println(JsonUtil.objectToJson(map));
		
		
		//System.out.println(kafkaInfo.getDictionaryValue("vacUrl"));
		
		//System.out.println(kafkaInfo.getDictionaryValue("vacUrl"));
		
	
		//System.out.println("======================="+Integer.parseInt(kafkaInfo.getTopicConf().get(0).get("RECORDS").toString()));
		SourceDataRecBean recBean = new SourceDataRecBean();
		recBean.setTopic("DOUYIN");
		recBean.setOffset(String.valueOf(231545));
		recBean.setPartition(String.valueOf(1));
		String dataJson = "{\"SERIAL_NUMBER\":\"17512008107\",\"ELEMENT_ID\":\"62567112\",\"REMAIN\":\"188\",\"KAFKA_TYPE\":\"r\",\"DEAL_TIME\":\"20201201093713\",\"PERCENT\":\"90\",\"EPARCHY_CODE\":\"0755\",\"USER_ID\":\"5120080363596515\",\"ADD_PRODUCT_ID\":\"90756541\",\"USED_VALUE\":\"2.82\",\"PROVINCE_CODE\":\"51\"}";
		//recBean.setSourcedata(dataJson);
		//int res = sourceDataRecDao.addDouyinSrcData(recBean);
		//System.out.println(sourceDataRecDao.addDouyinSrcData(recBean));
		

		String sql = " DELETE TD_KAFKA_SRCDATA_DOUYIN WHERE  RESULTCODE = '0' AND INSERTTIME < SYSDATE -1/24 ";
		
		//System.out.println(sourceDataRecDao.deldouyinSrcData(sql));
		
		//System.out.println(sourceDataRecDao.delDouyinSrcDataById("123456"));
		
		/***
		SourceDataRecBean recBean = new SourceDataRecBean();
		recBean.setTopic("KUAISHOU");
		recBean.setOffset(String.valueOf(231545));
		recBean.setPartition(String.valueOf(1));
		String dataJson = "{\"SERIAL_NUMBER\":\"15500155945\",\"ELEMENT_ID\":\"8664946\",\"REMAIN\":\"812\",\"KAFKA_TYPE\":\"r\",\"DEAL_TIME\":\"20201210163657\",\"PERCENT\":\"80\",\"EPARCHY_CODE\":\"0434\",\"USER_ID\":\"9019062464979374\",\"ADD_PRODUCT_ID\":\"90526927\",\"USED_VALUE\":\"3.21\",\"PROVINCE_CODE\":\"90\"}";
		recBean.setSourcedata(dataJson);
		recBean.setResultcode("8001");
		recBean.setResultinfo("非百分之百消耗，不处理");
		//int res = sourceDataRecDao.addDouyinSrcData(recBean);
		//System.out.println(sourceDataRecDao.addKuaishouSrcData(recBean));
		
		//System.out.println("++++++++++++++++++"+kafkaInfo.getProductConf("90305357").get(0).get("SPID"));
		
		//System.out.println("+++++++++++33333333333333++++++"+kafkaInfo.getProductConf("90305357").get(0).get("SPID"));
		//System.out.println(sourceDataRecDao.updBatchChengkaFlowData(sourceDataRecDao.getChengkaFlowData(10)));
		//System.out.println(kafkaInfo.getJobConf().get(0).getCRONEXPRESSION());
		
		//String sql = "UPDATE TD_KAFKA_SRCDATA SET RESULTCODE = '0', RESULTINFO = '成功', UPDTIME = SYSDATE WHERE ID = '20201204131850100081' ";
		//System.out.println("=========================="+sourceDataRecDao.updSrcDataBySql(sql));
		/*
		List<SourceDataRecBean> beans = new ArrayList<SourceDataRecBean>();
		SourceDataRecBean bean = new SourceDataRecBean();
		bean.setId("20201204142043100082");
		SourceDataRecBean bean2 = new SourceDataRecBean();
		bean2.setId("20201204142043100083");
		beans.add(bean);
		beans.add(bean2);
		//System.out.println("+++++++++++++++++++"+sourceDataRecDao.updBatchCommSrcData(beans));
		System.out.println(sourceDataRecDao.getCommSrcData("NewProdInfo",5));
		*/
		//String json = "{\"resultcode\":\"0\",\"errorinfo\":\"ok\"}";
		//Map map = (Map)JSON.parse(null);
		//System.out.println(map.get("resultcode"));
		//String jsondata = "{\"SERIAL_NUMBER\":\"17640027258\",\"ELEMENT_ID\":\"5856170\",\"REMAIN\":\"147\",\"KAFKA_TYPE\":\"r\",\"DEAL_TIME\":\"20210106134257\",\"PERCENT\":\"80\",\"EPARCHY_CODE\":\"0024\",\"USER_ID\":\"9117122954160506\",\"ADD_PRODUCT_ID\":\"90063345\",\"USED_VALUE\":\"0.64\",\"PROVINCE_CODE\":\"91\"}";
		//DouyinBean bgBean = (DouyinBean) JsonUtil.jsonToBean(jsondata, DouyinBean.class);
		//System.out.println(bgBean.getELEMENT_ID());
		String jsondata = "{\"USER_ID\":\"9721010726361091\",\"STATE_TAG\":\"0\",\"ACCEPT_DATE\":\"2021-01-07 09:28:27\",\"SERIAL_NUMBER\":\"18646189209\",\"PRODUCT_ID\":\"90981913\",\"START_DATE\":\"2021-01-07 09:31:21\",\"END_DATE\":\"2029-12-31 23:59:59\",\"KAFKA_TYPE\":\"p\",\"PROVINCE_CODE\":\"97\",\"EPARCHY_CODE\":\"0451\",\"DISCNT_CODE\":\"66687666\"}";
		BGbean bgBean = (BGbean)JsonUtil.jsonToBean(jsondata, BGbean.class);
		List<String> wopaiprodList = null;
		String wopaiprodconf = "66736525,66736560,66687666";
		String [] wopaiprod = null; //{"66736525","66736560","66687666"};
		if(wopaiprodconf != null && !"".equals(wopaiprodconf) && wopaiprodconf.length()>0){
			wopaiprod = wopaiprodconf.split(",");
			wopaiprodList = Arrays.asList(wopaiprod);
		}
		//System.out.println(wopaiprodList.get(2));
		//System.out.println("["+bgBean.getKAFKA_TYPE()+"]"+"["+bgBean.getDISCNT_CODE()+"]");
		if (wopaiprodList != null && "p".equals(bgBean.getKAFKA_TYPE()) && wopaiprodList.contains(bgBean.getDISCNT_CODE())){
			//System.out.println("沃派数据");
		}else{
			//System.out.println("不是沃派数据");
		}
	}
}
